(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/esm/defineProperty'), require('vue'), require('twind'), require('clsx'), require('lodash.merge')) :
  typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/esm/defineProperty', 'vue', 'twind', 'clsx', 'lodash.merge'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.Table = {}, global.defineProperty, global.Vue, global.twind, global.clsx, global.merge));
}(this, (function (exports, defineProperty, vue, twind, clsx, merge) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  var defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(defineProperty);
  var clsx__default = /*#__PURE__*/_interopDefaultLegacy(clsx);
  var merge__default = /*#__PURE__*/_interopDefaultLegacy(merge);

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(Object(source), true).forEach(function (key) {
          defineProperty__default['default'](target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(Object(source)).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  const variant = (args) => {
      return {
          variant: {
              type: args && args.type ? args.type : [String],
              default: args && args.default ? args.default : "",
              required: args && args.required ? args.required : false
          }
      };
  };
  const classAppend = (args) => {
      return {
          classAppend: {
              type: args && args.type ? args.type : [String, Array],
              default: args && args.default ? args.default : "",
              required: args && args.required ? args.required : false
          }
      };
  };
  const classRemove = (args) => {
      return {
          classRemove: {
              type: args && args.type ? args.type : [String, Array],
              default: args && args.default ? args.default : "",
              required: args && args.required ? args.required : false
          }
      };
  };

  // Classy
  class Classy {
      constructor(starter) {
          if (starter) {
              this.value = Array.isArray(starter) ? starter : this.toArray(starter);
          }
          else {
              this.value = [];
          }
      }
      // Chains
      append(classes) {
          this.value = clsx__default['default'](this.value, classes);
          return this;
      }
      remove(classes) {
          const classArray = typeof classes === "string" ? classes.split(" ") : classes;
          this.value = this.toArray(this.value).filter((className) => !classArray.includes(className));
          return this;
      }
      twind(enable = true) {
          if (enable) {
              this.value = twind.tw `${this.value}`;
          }
          return this;
      }
      val(type) {
          if (type === "array") {
              return this.toArray(this.value);
          }
          return clsx__default['default'](this.value);
      }
      // Helpers
      toArray(classes) {
          return typeof classes === "string" ? classes.split(" ") : classes;
      }
      toString(classes) {
          return Array.isArray(classes) ? classes.join(" ") : classes;
      }
  }

  var script = vue.defineComponent({
    props: _objectSpread2(_objectSpread2({}, classAppend({
      type: Object,
      default: {}
    })), classRemove({
      type: Object,
      default: {}
    })),
    setup: function setup(props) {
      var classes = vue.computed(function () {
        var _props$classAppend$ou, _props$classAppend, _props$classRemove$ou, _props$classRemove, _props$classAppend$in, _props$classAppend2, _props$classRemove$in, _props$classRemove2;

        return {
          outerWrapper: new Classy("-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8").append((_props$classAppend$ou = (_props$classAppend = props.classAppend) === null || _props$classAppend === void 0 ? void 0 : _props$classAppend.outerWrapper) !== null && _props$classAppend$ou !== void 0 ? _props$classAppend$ou : "").remove((_props$classRemove$ou = (_props$classRemove = props.classRemove) === null || _props$classRemove === void 0 ? void 0 : _props$classRemove.outerWrapper) !== null && _props$classRemove$ou !== void 0 ? _props$classRemove$ou : "").twind(vue.inject("twindEnable", true)).val(),
          innerWrapper: new Classy("inline-block min-w-full py-2 align-middle sm:px-6 lg:px-8").append((_props$classAppend$in = (_props$classAppend2 = props.classAppend) === null || _props$classAppend2 === void 0 ? void 0 : _props$classAppend2.innerWrapper) !== null && _props$classAppend$in !== void 0 ? _props$classAppend$in : "").remove((_props$classRemove$in = (_props$classRemove2 = props.classRemove) === null || _props$classRemove2 === void 0 ? void 0 : _props$classRemove2.innerWrapper) !== null && _props$classRemove$in !== void 0 ? _props$classRemove$in : "").twind(vue.inject("twindEnable", true)).val()
        };
      });
      return {
        classes: classes
      };
    }
  });

  function render(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createBlock("div", {
      class: _ctx.classes.outerWrapper
    }, [vue.createVNode("div", {
      class: _ctx.classes.innerWrapper
    }, [vue.renderSlot(_ctx.$slots, "default")], 2)], 2);
  }

  script.render = render;

  var script$1 = vue.defineComponent({
    name: "Thead",
    props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
      default: "primary"
    })),
    setup: function setup(props) {
      var _props$variant, _theme$resolvedVarian;

      var theme = vue.inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

      var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : vue.inject("variant", "primary");
      var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Thead) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
      var classes = vue.computed(function () {
        return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(vue.inject("twindEnable", true)).val();
      });
      return {
        classes: classes
      };
    }
  });

  function render$1(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createBlock("thead", {
      class: _ctx.classes
    }, [vue.renderSlot(_ctx.$slots, "default")], 2);
  }

  script$1.render = render$1;

  var script$2 = vue.defineComponent({
    props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
      default: "primary"
    })),
    setup: function setup(props) {
      var _props$variant, _theme$resolvedVarian;

      var theme = vue.inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

      var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : vue.inject("variant", "primary");
      var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Tbody) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
      var classes = vue.computed(function () {
        return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(vue.inject("twindEnable", true)).val();
      });
      return {
        classes: classes
      };
    }
  });

  function render$2(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createBlock("tbody", null, [vue.renderSlot(_ctx.$slots, "default")]);
  }

  script$2.render = render$2;

  var script$3 = vue.defineComponent({
    props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
      default: "primary"
    })),
    setup: function setup(props) {
      var _props$variant, _theme$resolvedVarian;

      var theme = vue.inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

      var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : vue.inject("variant", "primary");
      var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].tr) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
      var classes = vue.computed(function () {
        return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(vue.inject("twindEnable", true)).val();
      });
      return {
        classes: classes
      };
    }
  });

  function render$3(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createBlock("tr", {
      class: _ctx.classes
    }, [vue.renderSlot(_ctx.$slots, "default")], 2);
  }

  script$3.render = render$3;

  var script$4 = vue.defineComponent({
    props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
      default: "primary"
    })),
    setup: function setup(props) {
      var _props$variant, _theme$resolvedVarian;

      var theme = vue.inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

      var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : vue.inject("variant", "primary");
      var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Th) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
      var classes = vue.computed(function () {
        return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(vue.inject("twindEnable", true)).val();
      });
      return {
        classes: classes
      };
    }
  });

  function render$4(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createBlock("th", {
      scope: "col",
      class: _ctx.classes
    }, [vue.renderSlot(_ctx.$slots, "default")], 2);
  }

  script$4.render = render$4;

  var script$5 = vue.defineComponent({
    props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
      default: "primary"
    })),
    setup: function setup(props) {
      var _props$variant, _theme$resolvedVarian;

      var theme = vue.inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

      var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : vue.inject("variant", "primary");
      var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Td) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
      var classes = vue.computed(function () {
        return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(vue.inject("twindEnable", true)).val();
      });
      return {
        classes: classes
      };
    }
  });

  function render$5(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createBlock("td", {
      class: _ctx.classes
    }, [vue.renderSlot(_ctx.$slots, "default")], 2);
  }

  script$5.render = render$5;

  // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types, @typescript-eslint/no-explicit-any
  var Theme = (userTheme) => {
      return merge__default['default']({
          primary: {
              Table: "min-w-full",
              Thead: "border-b border-gray-200 dark:border-gray-800 bg-gray-100 dark:bg-gray-800",
              Tbody: "",
              Tr: "border-b border-gray-200 dark:border-gray-700 last:border-0",
              Th: "px-6 pt-4 pb-3 text-left text-xs font-medium text-gray-500 dark:text-gray-400 uppercase tracking-wider",
              Td: "px-6 py-4 whitespace-nowrap text-sm text-gray-900 dark:text-gray-100",
          },
      }, userTheme ? userTheme.Table : null);
  };

  var Table = vue.defineComponent({
    props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
      default: "primary"
    })),
    setup: function setup(props) {
      var _computed = vue.computed(function () {
        return Theme(vue.inject("userTheme", {}));
      }),
          theme = _computed.value;

      var classes = vue.computed(function () {
        return new Classy(theme[props.variant].Table).append(props.classAppend).remove(props.classRemove).twind(vue.inject("twindEnable", true)).val();
      });
      vue.provide("theme", theme);
      vue.provide("variant", props.variant);
      return {
        tw: twind.tw,
        classes: classes
      };
    }
  });

  function render$6(_ctx, _cache, $props, $setup, $data, $options) {
    return vue.openBlock(), vue.createBlock("table", {
      class: _ctx.classes
    }, [vue.renderSlot(_ctx.$slots, "default")], 2);
  }

  Table.render = render$6;

  const registerComponent = (instance, component) => {
      if (component) {
          instance.component(component.name || "", component);
      }
  };

  const TablePlugin = {
      // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
      install(vue) {
          registerComponent(vue, Table);
      },
  };

  exports.TablePlugin = TablePlugin;
  exports.default = Table;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
