import defineProperty$1 from '@babel/runtime/helpers/esm/defineProperty';
import { defineComponent, computed, inject, openBlock, createBlock, createVNode, renderSlot, createCommentVNode, resolveComponent, withCtx, h, resolveDynamicComponent, Transition, provide } from 'vue';
import clsx from 'clsx';
import { tw, silent, setup } from 'twind';
import merge from 'lodash.merge';
import 'core-js/modules/es.string.anchor.js';
import { MenuButton, MenuItem, MenuItems, Menu } from '@headlessui/vue';

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

function createCommonjsModule(fn, basedir, module) {
	return module = {
	  path: basedir,
	  exports: {},
	  require: function (path, base) {
      return commonjsRequire(path, (base === undefined || base === null) ? module.path : base);
    }
	}, fn(module, module.exports), module.exports;
}

function commonjsRequire () {
	throw new Error('Dynamic requires are not currently supported by @rollup/plugin-commonjs');
}

var check = function (it) {
  return it && it.Math == Math && it;
};

// https://github.com/zloirock/core-js/issues/86#issuecomment-115759028
var global_1 =
  // eslint-disable-next-line no-undef
  check(typeof globalThis == 'object' && globalThis) ||
  check(typeof window == 'object' && window) ||
  check(typeof self == 'object' && self) ||
  check(typeof commonjsGlobal == 'object' && commonjsGlobal) ||
  // eslint-disable-next-line no-new-func
  (function () { return this; })() || Function('return this')();

var fails = function (exec) {
  try {
    return !!exec();
  } catch (error) {
    return true;
  }
};

// Detect IE8's incomplete defineProperty implementation
var descriptors = !fails(function () {
  return Object.defineProperty({}, 1, { get: function () { return 7; } })[1] != 7;
});

var nativePropertyIsEnumerable = {}.propertyIsEnumerable;
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// Nashorn ~ JDK8 bug
var NASHORN_BUG = getOwnPropertyDescriptor && !nativePropertyIsEnumerable.call({ 1: 2 }, 1);

// `Object.prototype.propertyIsEnumerable` method implementation
// https://tc39.es/ecma262/#sec-object.prototype.propertyisenumerable
var f = NASHORN_BUG ? function propertyIsEnumerable(V) {
  var descriptor = getOwnPropertyDescriptor(this, V);
  return !!descriptor && descriptor.enumerable;
} : nativePropertyIsEnumerable;

var objectPropertyIsEnumerable = {
	f: f
};

var createPropertyDescriptor = function (bitmap, value) {
  return {
    enumerable: !(bitmap & 1),
    configurable: !(bitmap & 2),
    writable: !(bitmap & 4),
    value: value
  };
};

var toString = {}.toString;

var classofRaw = function (it) {
  return toString.call(it).slice(8, -1);
};

var split = ''.split;

// fallback for non-array-like ES3 and non-enumerable old V8 strings
var indexedObject = fails(function () {
  // throws an error in rhino, see https://github.com/mozilla/rhino/issues/346
  // eslint-disable-next-line no-prototype-builtins
  return !Object('z').propertyIsEnumerable(0);
}) ? function (it) {
  return classofRaw(it) == 'String' ? split.call(it, '') : Object(it);
} : Object;

// `RequireObjectCoercible` abstract operation
// https://tc39.es/ecma262/#sec-requireobjectcoercible
var requireObjectCoercible = function (it) {
  if (it == undefined) throw TypeError("Can't call method on " + it);
  return it;
};

// toObject with fallback for non-array-like ES3 strings



var toIndexedObject = function (it) {
  return indexedObject(requireObjectCoercible(it));
};

var isObject = function (it) {
  return typeof it === 'object' ? it !== null : typeof it === 'function';
};

// `ToPrimitive` abstract operation
// https://tc39.es/ecma262/#sec-toprimitive
// instead of the ES6 spec version, we didn't implement @@toPrimitive case
// and the second argument - flag - preferred type is a string
var toPrimitive = function (input, PREFERRED_STRING) {
  if (!isObject(input)) return input;
  var fn, val;
  if (PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
  if (typeof (fn = input.valueOf) == 'function' && !isObject(val = fn.call(input))) return val;
  if (!PREFERRED_STRING && typeof (fn = input.toString) == 'function' && !isObject(val = fn.call(input))) return val;
  throw TypeError("Can't convert object to primitive value");
};

var hasOwnProperty = {}.hasOwnProperty;

var has = function (it, key) {
  return hasOwnProperty.call(it, key);
};

var document$1 = global_1.document;
// typeof document.createElement is 'object' in old IE
var EXISTS = isObject(document$1) && isObject(document$1.createElement);

var documentCreateElement = function (it) {
  return EXISTS ? document$1.createElement(it) : {};
};

// Thank's IE8 for his funny defineProperty
var ie8DomDefine = !descriptors && !fails(function () {
  return Object.defineProperty(documentCreateElement('div'), 'a', {
    get: function () { return 7; }
  }).a != 7;
});

var nativeGetOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;

// `Object.getOwnPropertyDescriptor` method
// https://tc39.es/ecma262/#sec-object.getownpropertydescriptor
var f$1 = descriptors ? nativeGetOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
  O = toIndexedObject(O);
  P = toPrimitive(P, true);
  if (ie8DomDefine) try {
    return nativeGetOwnPropertyDescriptor(O, P);
  } catch (error) { /* empty */ }
  if (has(O, P)) return createPropertyDescriptor(!objectPropertyIsEnumerable.f.call(O, P), O[P]);
};

var objectGetOwnPropertyDescriptor = {
	f: f$1
};

var anObject = function (it) {
  if (!isObject(it)) {
    throw TypeError(String(it) + ' is not an object');
  } return it;
};

var nativeDefineProperty = Object.defineProperty;

// `Object.defineProperty` method
// https://tc39.es/ecma262/#sec-object.defineproperty
var f$2 = descriptors ? nativeDefineProperty : function defineProperty(O, P, Attributes) {
  anObject(O);
  P = toPrimitive(P, true);
  anObject(Attributes);
  if (ie8DomDefine) try {
    return nativeDefineProperty(O, P, Attributes);
  } catch (error) { /* empty */ }
  if ('get' in Attributes || 'set' in Attributes) throw TypeError('Accessors not supported');
  if ('value' in Attributes) O[P] = Attributes.value;
  return O;
};

var objectDefineProperty = {
	f: f$2
};

var createNonEnumerableProperty = descriptors ? function (object, key, value) {
  return objectDefineProperty.f(object, key, createPropertyDescriptor(1, value));
} : function (object, key, value) {
  object[key] = value;
  return object;
};

var setGlobal = function (key, value) {
  try {
    createNonEnumerableProperty(global_1, key, value);
  } catch (error) {
    global_1[key] = value;
  } return value;
};

var SHARED = '__core-js_shared__';
var store = global_1[SHARED] || setGlobal(SHARED, {});

var sharedStore = store;

var functionToString = Function.toString;

// this helper broken in `3.4.1-3.4.4`, so we can't use `shared` helper
if (typeof sharedStore.inspectSource != 'function') {
  sharedStore.inspectSource = function (it) {
    return functionToString.call(it);
  };
}

var inspectSource = sharedStore.inspectSource;

var WeakMap = global_1.WeakMap;

var nativeWeakMap = typeof WeakMap === 'function' && /native code/.test(inspectSource(WeakMap));

var shared = createCommonjsModule(function (module) {
(module.exports = function (key, value) {
  return sharedStore[key] || (sharedStore[key] = value !== undefined ? value : {});
})('versions', []).push({
  version: '3.8.2',
  mode:  'global',
  copyright: '© 2021 Denis Pushkarev (zloirock.ru)'
});
});

var id = 0;
var postfix = Math.random();

var uid = function (key) {
  return 'Symbol(' + String(key === undefined ? '' : key) + ')_' + (++id + postfix).toString(36);
};

var keys = shared('keys');

var sharedKey = function (key) {
  return keys[key] || (keys[key] = uid(key));
};

var hiddenKeys = {};

var WeakMap$1 = global_1.WeakMap;
var set, get, has$1;

var enforce = function (it) {
  return has$1(it) ? get(it) : set(it, {});
};

var getterFor = function (TYPE) {
  return function (it) {
    var state;
    if (!isObject(it) || (state = get(it)).type !== TYPE) {
      throw TypeError('Incompatible receiver, ' + TYPE + ' required');
    } return state;
  };
};

if (nativeWeakMap) {
  var store$1 = sharedStore.state || (sharedStore.state = new WeakMap$1());
  var wmget = store$1.get;
  var wmhas = store$1.has;
  var wmset = store$1.set;
  set = function (it, metadata) {
    metadata.facade = it;
    wmset.call(store$1, it, metadata);
    return metadata;
  };
  get = function (it) {
    return wmget.call(store$1, it) || {};
  };
  has$1 = function (it) {
    return wmhas.call(store$1, it);
  };
} else {
  var STATE = sharedKey('state');
  hiddenKeys[STATE] = true;
  set = function (it, metadata) {
    metadata.facade = it;
    createNonEnumerableProperty(it, STATE, metadata);
    return metadata;
  };
  get = function (it) {
    return has(it, STATE) ? it[STATE] : {};
  };
  has$1 = function (it) {
    return has(it, STATE);
  };
}

var internalState = {
  set: set,
  get: get,
  has: has$1,
  enforce: enforce,
  getterFor: getterFor
};

var redefine = createCommonjsModule(function (module) {
var getInternalState = internalState.get;
var enforceInternalState = internalState.enforce;
var TEMPLATE = String(String).split('String');

(module.exports = function (O, key, value, options) {
  var unsafe = options ? !!options.unsafe : false;
  var simple = options ? !!options.enumerable : false;
  var noTargetGet = options ? !!options.noTargetGet : false;
  var state;
  if (typeof value == 'function') {
    if (typeof key == 'string' && !has(value, 'name')) {
      createNonEnumerableProperty(value, 'name', key);
    }
    state = enforceInternalState(value);
    if (!state.source) {
      state.source = TEMPLATE.join(typeof key == 'string' ? key : '');
    }
  }
  if (O === global_1) {
    if (simple) O[key] = value;
    else setGlobal(key, value);
    return;
  } else if (!unsafe) {
    delete O[key];
  } else if (!noTargetGet && O[key]) {
    simple = true;
  }
  if (simple) O[key] = value;
  else createNonEnumerableProperty(O, key, value);
// add fake Function#toString for correct work wrapped methods / constructors with methods like LoDash isNative
})(Function.prototype, 'toString', function toString() {
  return typeof this == 'function' && getInternalState(this).source || inspectSource(this);
});
});

var path = global_1;

var aFunction = function (variable) {
  return typeof variable == 'function' ? variable : undefined;
};

var getBuiltIn = function (namespace, method) {
  return arguments.length < 2 ? aFunction(path[namespace]) || aFunction(global_1[namespace])
    : path[namespace] && path[namespace][method] || global_1[namespace] && global_1[namespace][method];
};

var ceil = Math.ceil;
var floor = Math.floor;

// `ToInteger` abstract operation
// https://tc39.es/ecma262/#sec-tointeger
var toInteger = function (argument) {
  return isNaN(argument = +argument) ? 0 : (argument > 0 ? floor : ceil)(argument);
};

var min = Math.min;

// `ToLength` abstract operation
// https://tc39.es/ecma262/#sec-tolength
var toLength = function (argument) {
  return argument > 0 ? min(toInteger(argument), 0x1FFFFFFFFFFFFF) : 0; // 2 ** 53 - 1 == 9007199254740991
};

var max = Math.max;
var min$1 = Math.min;

// Helper for a popular repeating case of the spec:
// Let integer be ? ToInteger(index).
// If integer < 0, let result be max((length + integer), 0); else let result be min(integer, length).
var toAbsoluteIndex = function (index, length) {
  var integer = toInteger(index);
  return integer < 0 ? max(integer + length, 0) : min$1(integer, length);
};

// `Array.prototype.{ indexOf, includes }` methods implementation
var createMethod = function (IS_INCLUDES) {
  return function ($this, el, fromIndex) {
    var O = toIndexedObject($this);
    var length = toLength(O.length);
    var index = toAbsoluteIndex(fromIndex, length);
    var value;
    // Array#includes uses SameValueZero equality algorithm
    // eslint-disable-next-line no-self-compare
    if (IS_INCLUDES && el != el) while (length > index) {
      value = O[index++];
      // eslint-disable-next-line no-self-compare
      if (value != value) return true;
    // Array#indexOf ignores holes, Array#includes - not
    } else for (;length > index; index++) {
      if ((IS_INCLUDES || index in O) && O[index] === el) return IS_INCLUDES || index || 0;
    } return !IS_INCLUDES && -1;
  };
};

var arrayIncludes = {
  // `Array.prototype.includes` method
  // https://tc39.es/ecma262/#sec-array.prototype.includes
  includes: createMethod(true),
  // `Array.prototype.indexOf` method
  // https://tc39.es/ecma262/#sec-array.prototype.indexof
  indexOf: createMethod(false)
};

var indexOf = arrayIncludes.indexOf;


var objectKeysInternal = function (object, names) {
  var O = toIndexedObject(object);
  var i = 0;
  var result = [];
  var key;
  for (key in O) !has(hiddenKeys, key) && has(O, key) && result.push(key);
  // Don't enum bug & hidden keys
  while (names.length > i) if (has(O, key = names[i++])) {
    ~indexOf(result, key) || result.push(key);
  }
  return result;
};

// IE8- don't enum bug keys
var enumBugKeys = [
  'constructor',
  'hasOwnProperty',
  'isPrototypeOf',
  'propertyIsEnumerable',
  'toLocaleString',
  'toString',
  'valueOf'
];

var hiddenKeys$1 = enumBugKeys.concat('length', 'prototype');

// `Object.getOwnPropertyNames` method
// https://tc39.es/ecma262/#sec-object.getownpropertynames
var f$3 = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
  return objectKeysInternal(O, hiddenKeys$1);
};

var objectGetOwnPropertyNames = {
	f: f$3
};

var f$4 = Object.getOwnPropertySymbols;

var objectGetOwnPropertySymbols = {
	f: f$4
};

// all object keys, includes non-enumerable and symbols
var ownKeys = getBuiltIn('Reflect', 'ownKeys') || function ownKeys(it) {
  var keys = objectGetOwnPropertyNames.f(anObject(it));
  var getOwnPropertySymbols = objectGetOwnPropertySymbols.f;
  return getOwnPropertySymbols ? keys.concat(getOwnPropertySymbols(it)) : keys;
};

var copyConstructorProperties = function (target, source) {
  var keys = ownKeys(source);
  var defineProperty = objectDefineProperty.f;
  var getOwnPropertyDescriptor = objectGetOwnPropertyDescriptor.f;
  for (var i = 0; i < keys.length; i++) {
    var key = keys[i];
    if (!has(target, key)) defineProperty(target, key, getOwnPropertyDescriptor(source, key));
  }
};

var replacement = /#|\.prototype\./;

var isForced = function (feature, detection) {
  var value = data[normalize(feature)];
  return value == POLYFILL ? true
    : value == NATIVE ? false
    : typeof detection == 'function' ? fails(detection)
    : !!detection;
};

var normalize = isForced.normalize = function (string) {
  return String(string).replace(replacement, '.').toLowerCase();
};

var data = isForced.data = {};
var NATIVE = isForced.NATIVE = 'N';
var POLYFILL = isForced.POLYFILL = 'P';

var isForced_1 = isForced;

var getOwnPropertyDescriptor$1 = objectGetOwnPropertyDescriptor.f;






/*
  options.target      - name of the target object
  options.global      - target is the global object
  options.stat        - export as static methods of target
  options.proto       - export as prototype methods of target
  options.real        - real prototype method for the `pure` version
  options.forced      - export even if the native feature is available
  options.bind        - bind methods to the target, required for the `pure` version
  options.wrap        - wrap constructors to preventing global pollution, required for the `pure` version
  options.unsafe      - use the simple assignment of property instead of delete + defineProperty
  options.sham        - add a flag to not completely full polyfills
  options.enumerable  - export as enumerable property
  options.noTargetGet - prevent calling a getter on target
*/
var _export = function (options, source) {
  var TARGET = options.target;
  var GLOBAL = options.global;
  var STATIC = options.stat;
  var FORCED, target, key, targetProperty, sourceProperty, descriptor;
  if (GLOBAL) {
    target = global_1;
  } else if (STATIC) {
    target = global_1[TARGET] || setGlobal(TARGET, {});
  } else {
    target = (global_1[TARGET] || {}).prototype;
  }
  if (target) for (key in source) {
    sourceProperty = source[key];
    if (options.noTargetGet) {
      descriptor = getOwnPropertyDescriptor$1(target, key);
      targetProperty = descriptor && descriptor.value;
    } else targetProperty = target[key];
    FORCED = isForced_1(GLOBAL ? key : TARGET + (STATIC ? '.' : '#') + key, options.forced);
    // contained in target
    if (!FORCED && targetProperty !== undefined) {
      if (typeof sourceProperty === typeof targetProperty) continue;
      copyConstructorProperties(sourceProperty, targetProperty);
    }
    // add a flag to not completely full polyfills
    if (options.sham || (targetProperty && targetProperty.sham)) {
      createNonEnumerableProperty(sourceProperty, 'sham', true);
    }
    // extend global
    redefine(target, key, sourceProperty, options);
  }
};

var quot = /"/g;

// B.2.3.2.1 CreateHTML(string, tag, attribute, value)
// https://tc39.es/ecma262/#sec-createhtml
var createHtml = function (string, tag, attribute, value) {
  var S = String(requireObjectCoercible(string));
  var p1 = '<' + tag;
  if (attribute !== '') p1 += ' ' + attribute + '="' + String(value).replace(quot, '&quot;') + '"';
  return p1 + '>' + S + '</' + tag + '>';
};

// check the existence of a method, lowercase
// of a tag and escaping quotes in arguments
var stringHtmlForced = function (METHOD_NAME) {
  return fails(function () {
    var test = ''[METHOD_NAME]('"');
    return test !== test.toLowerCase() || test.split('"').length > 3;
  });
};

// `String.prototype.anchor` method
// https://tc39.es/ecma262/#sec-string.prototype.anchor
_export({ target: 'String', proto: true, forced: stringHtmlForced('anchor') }, {
  anchor: function anchor(name) {
    return createHtml(this, 'a', 'name', name);
  }
});

function ownKeys$1(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys$1(Object(source), true).forEach(function (key) {
        defineProperty$1(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys$1(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

const variant = (args) => {
    return {
        variant: {
            type: args && args.type ? args.type : [String],
            default: args && args.default ? args.default : "",
            required: args && args.required ? args.required : false
        }
    };
};
const classAppend = (args) => {
    return {
        classAppend: {
            type: args && args.type ? args.type : [String, Array],
            default: args && args.default ? args.default : "",
            required: args && args.required ? args.required : false
        }
    };
};
const classRemove = (args) => {
    return {
        classRemove: {
            type: args && args.type ? args.type : [String, Array],
            default: args && args.default ? args.default : "",
            required: args && args.required ? args.required : false
        }
    };
};
const as = (args) => {
    return {
        as: {
            type: args && args.type ? args.type : [String, Object],
            default: args && args.default ? args.default : "div",
            required: args && args.required ? args.required : false
        }
    };
};
const status = (args) => {
    return {
        status: {
            type: args && args.type ? args.type : [String, Boolean],
            default: args && args.default ? args.default : false,
            required: args && args.required ? args.required : false,
            validator: args && args.validator ? args.validator : () => true
        }
    };
};
const size = (args) => {
    return {
        size: {
            type: args && args.type ? args.type : [String],
            default: args && args.default ? args.default : "",
            required: args && args.required ? args.required : false,
            validator: args && args.validator ? args.validator : () => true
        }
    };
};

// Classy
class Classy {
    constructor(starter) {
        if (starter) {
            this.value = Array.isArray(starter) ? starter : this.toArray(starter);
        }
        else {
            this.value = [];
        }
    }
    // Chains
    append(classes) {
        this.value = clsx(this.value, classes);
        return this;
    }
    remove(classes) {
        const classArray = typeof classes === "string" ? classes.split(" ") : classes;
        this.value = this.toArray(this.value).filter((className) => !classArray.includes(className));
        return this;
    }
    twind(enable = true) {
        if (enable) {
            this.value = tw `${this.value}`;
        }
        return this;
    }
    val(type) {
        if (type === "array") {
            return this.toArray(this.value);
        }
        return clsx(this.value);
    }
    // Helpers
    toArray(classes) {
        return typeof classes === "string" ? classes.split(" ") : classes;
    }
    toString(classes) {
        return Array.isArray(classes) ? classes.join(" ") : classes;
    }
}

const anchorBase = 'inline-flex space-x-2 focus:ring-2 rounded-sm ring-opacity-50 outline-none';
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types, @typescript-eslint/no-explicit-any
const Theme = (userTheme) => {
    return merge({
        BASE: anchorBase,
        primary: `${anchorBase} text-green-500 hover:text-green-800 focus:text-green-800 dark:hover:text-green-300 dark:focus:text-green-300 ring-green-500`,
        secondary: `${anchorBase} text-blue-500 dark:text-blue-400 hover:text-blue-700 dark:hover:text-blue-300 focus:text-blue-800 dark:focus:text-blue-300 ring-blue-500`,
    }, userTheme ? userTheme.Anchor : null);
};

var script = defineComponent({
  name: "Anchor",
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend({
    type: [String, Object]
  })), classRemove({
    type: [String, Object]
  })), variant({
    default: "BASE"
  })), {}, {
    href: {
      type: String,
      required: true
    },
    newTab: {
      type: Boolean,
      default: false
    }
  }),
  setup: function setup(props) {
    var _computed = computed(function () {
      return Theme(inject("userTheme", {}));
    }),
        theme = _computed.value;

    var variantIsStr = typeof props.variant === "string";
    var classAppendIsStr = typeof props.classAppend === "string";
    var classRemoveIsStr = typeof props.classRemove === "string";
    var classes = computed(function () {
      var _props$classAppend$ic, _props$classRemove$ic;

      return {
        anchor: new Classy().append(theme[variantIsStr ? props.variant : props.variant.anchor]).append(classAppendIsStr ? props.classAppend : props.classAppend.anchor).remove(classRemoveIsStr ? props.classRemove : props.classRemove.anchor).twind().val(),
        icon: new Classy() // .append(props.variant.icon ? theme[props.variant.icon] : "")
        .append((_props$classAppend$ic = props.classAppend.icon) !== null && _props$classAppend$ic !== void 0 ? _props$classAppend$ic : "w-4").remove((_props$classRemove$ic = props.classRemove.icon) !== null && _props$classRemove$ic !== void 0 ? _props$classRemove$ic : "").twind().val()
      };
    });
    return {
      classes: classes
    };
  }
});

var _hoisted_1 = /*#__PURE__*/createVNode("path", {
  d: "M11 3a1 1 0 100 2h2.586l-6.293 6.293a1 1 0 101.414 1.414L15 6.414V9a1 1 0 102 0V4a1 1 0 00-1-1h-5z"
}, null, -1);

var _hoisted_2 = /*#__PURE__*/createVNode("path", {
  d: "M5 5a2 2 0 00-2 2v8a2 2 0 002 2h8a2 2 0 002-2v-3a1 1 0 10-2 0v3H5V7h3a1 1 0 000-2H5z"
}, null, -1);

function render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("a", {
    class: _ctx.classes.anchor,
    href: _ctx.href,
    rel: _ctx.newTab ? 'noopener noreferrer' : null,
    target: _ctx.newTab ? '_blank' : null
  }, [createVNode("div", null, [renderSlot(_ctx.$slots, "default")]), _ctx.newTab ? (openBlock(), createBlock("svg", {
    key: 0,
    class: _ctx.classes.icon,
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 20 20",
    fill: "currentColor"
  }, [_hoisted_1, _hoisted_2], 2)) : createCommentVNode("", true)], 10, ["href", "rel", "target"]);
}

script.render = render;

const registerComponent = (instance, component) => {
    if (component) {
        instance.component(component.name || "", component);
    }
};

const AnchorPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install: (vue) => {
        registerComponent(vue, script);
    }
};

var nativeSymbol = !!Object.getOwnPropertySymbols && !fails(function () {
  // Chrome 38 Symbol has incorrect toString conversion
  // eslint-disable-next-line no-undef
  return !String(Symbol());
});

var useSymbolAsUid = nativeSymbol
  // eslint-disable-next-line no-undef
  && !Symbol.sham
  // eslint-disable-next-line no-undef
  && typeof Symbol.iterator == 'symbol';

var WellKnownSymbolsStore = shared('wks');
var Symbol$1 = global_1.Symbol;
var createWellKnownSymbol = useSymbolAsUid ? Symbol$1 : Symbol$1 && Symbol$1.withoutSetter || uid;

var wellKnownSymbol = function (name) {
  if (!has(WellKnownSymbolsStore, name)) {
    if (nativeSymbol && has(Symbol$1, name)) WellKnownSymbolsStore[name] = Symbol$1[name];
    else WellKnownSymbolsStore[name] = createWellKnownSymbol('Symbol.' + name);
  } return WellKnownSymbolsStore[name];
};

// `Object.keys` method
// https://tc39.es/ecma262/#sec-object.keys
var objectKeys = Object.keys || function keys(O) {
  return objectKeysInternal(O, enumBugKeys);
};

// `Object.defineProperties` method
// https://tc39.es/ecma262/#sec-object.defineproperties
var objectDefineProperties = descriptors ? Object.defineProperties : function defineProperties(O, Properties) {
  anObject(O);
  var keys = objectKeys(Properties);
  var length = keys.length;
  var index = 0;
  var key;
  while (length > index) objectDefineProperty.f(O, key = keys[index++], Properties[key]);
  return O;
};

var html = getBuiltIn('document', 'documentElement');

var GT = '>';
var LT = '<';
var PROTOTYPE = 'prototype';
var SCRIPT = 'script';
var IE_PROTO = sharedKey('IE_PROTO');

var EmptyConstructor = function () { /* empty */ };

var scriptTag = function (content) {
  return LT + SCRIPT + GT + content + LT + '/' + SCRIPT + GT;
};

// Create object with fake `null` prototype: use ActiveX Object with cleared prototype
var NullProtoObjectViaActiveX = function (activeXDocument) {
  activeXDocument.write(scriptTag(''));
  activeXDocument.close();
  var temp = activeXDocument.parentWindow.Object;
  activeXDocument = null; // avoid memory leak
  return temp;
};

// Create object with fake `null` prototype: use iframe Object with cleared prototype
var NullProtoObjectViaIFrame = function () {
  // Thrash, waste and sodomy: IE GC bug
  var iframe = documentCreateElement('iframe');
  var JS = 'java' + SCRIPT + ':';
  var iframeDocument;
  iframe.style.display = 'none';
  html.appendChild(iframe);
  // https://github.com/zloirock/core-js/issues/475
  iframe.src = String(JS);
  iframeDocument = iframe.contentWindow.document;
  iframeDocument.open();
  iframeDocument.write(scriptTag('document.F=Object'));
  iframeDocument.close();
  return iframeDocument.F;
};

// Check for document.domain and active x support
// No need to use active x approach when document.domain is not set
// see https://github.com/es-shims/es5-shim/issues/150
// variation of https://github.com/kitcambridge/es5-shim/commit/4f738ac066346
// avoid IE GC bug
var activeXDocument;
var NullProtoObject = function () {
  try {
    /* global ActiveXObject */
    activeXDocument = document.domain && new ActiveXObject('htmlfile');
  } catch (error) { /* ignore */ }
  NullProtoObject = activeXDocument ? NullProtoObjectViaActiveX(activeXDocument) : NullProtoObjectViaIFrame();
  var length = enumBugKeys.length;
  while (length--) delete NullProtoObject[PROTOTYPE][enumBugKeys[length]];
  return NullProtoObject();
};

hiddenKeys[IE_PROTO] = true;

// `Object.create` method
// https://tc39.es/ecma262/#sec-object.create
var objectCreate = Object.create || function create(O, Properties) {
  var result;
  if (O !== null) {
    EmptyConstructor[PROTOTYPE] = anObject(O);
    result = new EmptyConstructor();
    EmptyConstructor[PROTOTYPE] = null;
    // add "__proto__" for Object.getPrototypeOf polyfill
    result[IE_PROTO] = O;
  } else result = NullProtoObject();
  return Properties === undefined ? result : objectDefineProperties(result, Properties);
};

var UNSCOPABLES = wellKnownSymbol('unscopables');
var ArrayPrototype = Array.prototype;

// Array.prototype[@@unscopables]
// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
if (ArrayPrototype[UNSCOPABLES] == undefined) {
  objectDefineProperty.f(ArrayPrototype, UNSCOPABLES, {
    configurable: true,
    value: objectCreate(null)
  });
}

// add a key to Array.prototype[@@unscopables]
var addToUnscopables = function (key) {
  ArrayPrototype[UNSCOPABLES][key] = true;
};

var defineProperty = Object.defineProperty;
var cache = {};

var thrower = function (it) { throw it; };

var arrayMethodUsesToLength = function (METHOD_NAME, options) {
  if (has(cache, METHOD_NAME)) return cache[METHOD_NAME];
  if (!options) options = {};
  var method = [][METHOD_NAME];
  var ACCESSORS = has(options, 'ACCESSORS') ? options.ACCESSORS : false;
  var argument0 = has(options, 0) ? options[0] : thrower;
  var argument1 = has(options, 1) ? options[1] : undefined;

  return cache[METHOD_NAME] = !!method && !fails(function () {
    if (ACCESSORS && !descriptors) return true;
    var O = { length: -1 };

    if (ACCESSORS) defineProperty(O, 1, { enumerable: true, get: thrower });
    else O[1] = 1;

    method.call(O, argument0, argument1);
  });
};

var $includes = arrayIncludes.includes;



var USES_TO_LENGTH = arrayMethodUsesToLength('indexOf', { ACCESSORS: true, 1: 0 });

// `Array.prototype.includes` method
// https://tc39.es/ecma262/#sec-array.prototype.includes
_export({ target: 'Array', proto: true, forced: !USES_TO_LENGTH }, {
  includes: function includes(el /* , fromIndex = 0 */) {
    return $includes(this, el, arguments.length > 1 ? arguments[1] : undefined);
  }
});

// https://tc39.es/ecma262/#sec-array.prototype-@@unscopables
addToUnscopables('includes');

const buttonDefault = "inline-flex items-center border-2 font-medium rounded-md leading-6 focus:relative focus:z-20 focus:ring-opacity-60 focus:outline-none focus:ring-2 focus:ring-offset-2";
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types, @typescript-eslint/no-explicit-any
const Theme$1 = (userTheme) => {
    return merge({
        primary: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-blue-900 ring-offset-blue-50 bg-blue-600 hover:bg-blue-700 focus:ring-blue-500`,
        secondary: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-gray-900 ring-offset-gray-50 bg-gray-600 hover:bg-gray-700 focus:ring-gray-500`,
        outline: `${buttonDefault} text-gray-700 dark:text-gray-100 border-gray-400 dark:border-gray-600 focus:border-gray-500 ring-offset-gray-50 dark:ring-offset-gray-800 hover:bg-gray-500 hover:bg-opacity-10 hover:dark:bg-gray-200 hover:dark:bg-opacity-10 focus:bg-gray-900 focus:dark:bg-gray-100 focus:bg-opacity-10 focus:dark:bg-opacity-20 focus:ring-gray-400 px-3.5 py-1.5`,
        success: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-green-900 ring-offset-green-50 bg-green-600 hover:bg-green-700 focus:ring-green-500`,
        danger: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-red-900 ring-offset-red-50 bg-red-600 hover:bg-red-700 focus:ring-red-500`,
        warn: `${buttonDefault} border-transparent shadow-sm text-white dark:ring-offset-yellow-900 ring-offset-yellow-50 bg-yellow-600 hover:bg-yellow-700 focus:ring-yellow-500`,
        disabled: `${buttonDefault} bg-indigo-600 hover:bg-indigo-700 focus:ring-indigo-500`,
        size: {
            xs: "px-1 leading-5 text-xs",
            sm: "px-2.5 py-0.5 py text-sm",
            md: "px-3.5 py-1.5",
            lg: "px-5 py-2.5 text-lg",
            xl: "px-6 py-4 text-xl",
        },
    }, userTheme ? userTheme.ZButton : null);
};

var script$1 = defineComponent({
  name: "Button",
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })), status({
    default: "default",
    validator: function validator(v) {
      return ["loading", "default"].includes(v);
    }
  })), size({
    default: "md",
    validator: function validator(v) {
      return ["xs", "sm", "md", "lg", "xl"].includes(v);
    }
  })),
  setup: function setup(props) {
    var _computed = computed(function () {
      return Theme$1(inject("userTheme", {}));
    }),
        theme = _computed.value;

    var classes = computed(function () {
      return new Classy().append(theme[props.variant]).append(theme.size[props.size]).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$1(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("button", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$1.render = render$1;

const ButtonPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install: (vue) => {
        registerComponent(vue, script$1);
    }
};

var script$2 = defineComponent({
  name: "DropdownButton",
  components: {
    HMenuButton: MenuButton
  },
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "DEFAULT"
  })), status()), as({
    default: "button"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var twindEnable = inject("twindEnable", true);
    var status = props.status && props.status !== false ? props.status : inject("status", false);
    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "DEFAULT");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].DropdownButton) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var statusClasses = status && theme[status] ? theme[status].DropdownButton : false;
    var classes = computed(function () {
      return new Classy().append(statusClasses !== null && statusClasses !== void 0 ? statusClasses : theme[variantClasses]).append(props.classAppend).remove(props.classRemove).twind(twindEnable).val();
    });
    return {
      classes: classes,
      status: status
    };
  }
});

function render$2(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_HMenuButton = resolveComponent("HMenuButton");

  return openBlock(), createBlock(_component_HMenuButton, {
    as: _ctx.status === 'disabled' ? 'button' : _ctx.as,
    class: _ctx.classes,
    disabled: _ctx.status === 'disabled'
  }, {
    default: withCtx(function (_ref) {
      var open = _ref.open;
      return [renderSlot(_ctx.$slots, "default", {
        open: open
      })];
    }),
    _: 3
  }, 8, ["as", "class", "disabled"]);
}

script$2.render = render$2;

var HtmlElement = defineComponent({
  name: "HtmlElement",
  props: {
    el: {
      type: [Object, String],
      default: "div"
    }
  },
  setup: function setup(props, _ref) {
    var slots = _ref.slots;
    return function () {
      var _slots$default;

      return h(props.el, {}, slots === null || slots === void 0 ? void 0 : (_slots$default = slots.default) === null || _slots$default === void 0 ? void 0 : _slots$default.call(slots));
    };
  }
});
var script$3 = defineComponent({
  name: "DropdownItem",
  components: {
    HMenuItem: MenuItem,
    HtmlElement: HtmlElement
  },
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend({
    type: Object,
    default: {
      BASE: "",
      active: "",
      inactive: ""
    }
  })), classRemove({
    type: Object,
    default: {
      BASE: "",
      active: "",
      inactive: ""
    }
  })), variant({
    default: "DEFAULT"
  })), as({
    default: "button"
  })), status({
    default: false,
    validator: function validator(v) {
      return !v || ["disabled"].includes(v);
    }
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var twindEnable = inject("twindEnable", true);
    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "DEFAULT");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].DropdownItem) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : console.error("Could not find variant classes.");
    var statusClasses = props.status && theme[props.status] ? theme[props.status].DropdownItem : false;
    var classes = computed(function () {
      var _statusClasses$BASE, _props$classAppend, _props$classRemove, _props$classAppend2, _props$classRemove2, _props$classAppend3, _props$classRemove3;

      return {
        BASE: new Classy().append((_statusClasses$BASE = statusClasses.BASE) !== null && _statusClasses$BASE !== void 0 ? _statusClasses$BASE : variantClasses === null || variantClasses === void 0 ? void 0 : variantClasses.BASE).append((_props$classAppend = props.classAppend) === null || _props$classAppend === void 0 ? void 0 : _props$classAppend.BASE).remove((_props$classRemove = props.classRemove) === null || _props$classRemove === void 0 ? void 0 : _props$classRemove.BASE).twind(twindEnable).val(),
        active: new Classy().append(variantClasses === null || variantClasses === void 0 ? void 0 : variantClasses.active).append((_props$classAppend2 = props.classAppend) === null || _props$classAppend2 === void 0 ? void 0 : _props$classAppend2.active).remove((_props$classRemove2 = props.classRemove) === null || _props$classRemove2 === void 0 ? void 0 : _props$classRemove2.active).twind(twindEnable).val(),
        inactive: new Classy().append(variantClasses === null || variantClasses === void 0 ? void 0 : variantClasses.inactive).append((_props$classAppend3 = props.classAppend) === null || _props$classAppend3 === void 0 ? void 0 : _props$classAppend3.inactive).remove((_props$classRemove3 = props.classRemove) === null || _props$classRemove3 === void 0 ? void 0 : _props$classRemove3.inactive).twind(twindEnable).val()
      };
    });
    return {
      classes: classes
    };
  }
});

function render$3(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_HtmlElement = resolveComponent("HtmlElement");

  var _component_HMenuItem = resolveComponent("HMenuItem");

  return openBlock(), createBlock(_component_HMenuItem, {
    as: "template",
    disabled: _ctx.status === 'disabled'
  }, {
    default: withCtx(function (_ref) {
      var active = _ref.active;
      return [typeof _ctx.as === 'string' ? (openBlock(), createBlock(_component_HtmlElement, {
        key: 0,
        el: _ctx.as,
        class: [active ? _ctx.classes.active : _ctx.classes.inactive, _ctx.classes.BASE]
      }, {
        default: withCtx(function () {
          return [renderSlot(_ctx.$slots, "default", {
            active: active
          })];
        }),
        _: 2
      }, 1032, ["el", "class"])) : (openBlock(), createBlock(resolveDynamicComponent(_ctx.as), {
        key: 1
      }, {
        default: withCtx(function () {
          return [renderSlot(_ctx.$slots, "default", {
            active: active
          })];
        }),
        _: 2
      }, 1024))];
    }),
    _: 1
  }, 8, ["disabled"]);
}

script$3.render = render$3;

var script$4 = defineComponent({
  name: "DropdownItems",
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "DEFAULT"
  })), status()),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var status = inject("status");
    var align = inject("align", "left");
    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "DEFAULT");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].DropdownItems) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return {
        items: new Classy().append(variantClasses).append(theme.align[align]).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val(),
        transition: {
          enterActiveClass: new Classy(theme.transition.DEFAULT.enterActiveClass).twind().val(),
          enterFromClass: new Classy(theme.transition.DEFAULT.enterFromClass).twind().val(),
          enterToClass: new Classy(theme.transition.DEFAULT.enterToClass).twind().val(),
          leaveActiveClass: new Classy(theme.transition.DEFAULT.leaveActiveClass).twind().val(),
          leaveFromClass: new Classy(theme.transition.DEFAULT.leaveFromClass).twind().val(),
          leaveToClass: new Classy(theme.transition.DEFAULT.leaveToClass).twind().val()
        }
      };
    });
    return {
      classes: classes,
      tw: tw,
      status: status
    };
  },
  components: {
    HMenuItems: MenuItems
  }
});

function render$4(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_HMenuItems = resolveComponent("HMenuItems");

  return _ctx.status !== 'disabled' ? (openBlock(), createBlock(Transition, {
    key: 0,
    "enter-active-class": _ctx.classes.transition.enterActiveClass,
    "enter-from-class": _ctx.classes.transition.enterFromClass,
    "enter-to-class": _ctx.classes.transition.enterToClass,
    "leave-active-class": _ctx.classes.transition.leaveActiveClass,
    "leave-from-class": _ctx.classes.transition.leaveFromClass,
    "leave-to-class": _ctx.classes.transition.leaveToClass
  }, {
    default: withCtx(function () {
      return [createVNode(_component_HMenuItems, {
        class: _ctx.classes.items
      }, {
        default: withCtx(function () {
          return [renderSlot(_ctx.$slots, "default")];
        }),
        _: 3
      }, 8, ["class"])];
    }),
    _: 1
  }, 8, ["enter-active-class", "enter-from-class", "enter-to-class", "leave-active-class", "leave-from-class", "leave-to-class"])) : createCommentVNode("", true);
}

script$4.render = render$4;

const dropDownBase = {
    Dropdown: "relative inline-block text-left",
    DropdownButton: "",
    DropdownItems: "absolute z-10 w-56 mt-2 overflow-hidden bg-white border border-gray-200 divide-y divide-gray-100 rounded-md shadow-lg outline-none",
};
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types, @typescript-eslint/no-explicit-any
const Theme$2 = (userTheme) => {
    return merge({
        DEFAULT: {
            ...dropDownBase,
            DropdownItem: {
                BASE: "flex justify-between w-full px-4 py-2 text-sm leading-5 text-left",
                active: "bg-gray-100 text-gray-900",
                inactive: "text-gray-700",
            },
        },
        danger: {
            DropdownItem: {
                BASE: "flex justify-between w-full px-4 py-2 text-sm leading-5 text-left",
                active: "bg-red-100 text-red-900",
                inactive: "text-gray-700",
            }
        },
        success: {
            DropdownItem: {
                BASE: "flex justify-between w-full px-4 py-2 text-sm leading-5 text-left",
                active: "bg-green-100 text-green-900",
                inactive: "text-gray-700",
            }
        },
        disabled: {
            DropdownButton: "cursor-not-allowed",
            DropdownItem: {
                BASE: "text-gray-300 flex justify-between w-full px-4 py-2 text-sm leading-5 text-left cursor-not-allowed",
                active: "",
                inactive: "",
            }
        },
        align: {
            left: "right-0 origin-top-right",
            right: "left-0 origin-top-left"
        },
        transition: {
            DEFAULT: {
                enterActiveClass: "transition duration-100 ease-out",
                enterFromClass: "transform scale-95 opacity-0",
                enterToClass: "transform scale-100 opacity-100",
                leaveActiveClass: "transition duration-75 ease-out",
                leaveFromClass: "transform scale-100 opacity-100",
                leaveToClass: "transform scale-95 opacity-0",
            }
        }
    }, userTheme ? userTheme.ZDropdown : null);
};

var Dropdown = defineComponent({
  name: "Dropdown",
  components: {
    HMenu: Menu
  },
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "DEFAULT"
  })), status()), as({
    default: "template"
  })), {}, {
    align: {
      type: String,
      default: "left",
      validator: function validator(v) {
        return ["right", "left"].includes(v);
      }
    }
  }),
  setup: function setup(props) {
    var _computed = computed(function () {
      return Theme$2(inject("userTheme", {}));
    }),
        theme = _computed.value;

    var classes = computed(function () {
      return new Classy().append(theme[props.variant].Dropdown).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    provide("theme", theme);
    provide("variant", props.variant);
    provide("align", props.align);
    provide("status", props.status);
    return {
      classes: classes
    };
  }
});

function render$5(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_HMenu = resolveComponent("HMenu");

  return openBlock(), createBlock("div", {
    class: _ctx.classes
  }, [createVNode(_component_HMenu, {
    as: _ctx.as
  }, {
    default: withCtx(function (_ref) {
      var open = _ref.open;
      return [renderSlot(_ctx.$slots, "default", {
        open: open,
        variant: _ctx.variant
      })];
    }),
    _: 3
  }, 8, ["as"])], 2);
}

Dropdown.render = render$5;

const DropdownPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, Dropdown);
    },
};
const DropdownButtonPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, script$2);
    },
};
const DropdownItemsPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, script$4);
    },
};
const DropdownItemPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, script$3);
    },
};

var script$5 = defineComponent({
  props: _objectSpread2(_objectSpread2({}, classAppend({
    type: Object,
    default: {}
  })), classRemove({
    type: Object,
    default: {}
  })),
  setup: function setup(props) {
    var classes = computed(function () {
      var _props$classAppend$ou, _props$classAppend, _props$classRemove$ou, _props$classRemove, _props$classAppend$in, _props$classAppend2, _props$classRemove$in, _props$classRemove2;

      return {
        outerWrapper: new Classy("-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8").append((_props$classAppend$ou = (_props$classAppend = props.classAppend) === null || _props$classAppend === void 0 ? void 0 : _props$classAppend.outerWrapper) !== null && _props$classAppend$ou !== void 0 ? _props$classAppend$ou : "").remove((_props$classRemove$ou = (_props$classRemove = props.classRemove) === null || _props$classRemove === void 0 ? void 0 : _props$classRemove.outerWrapper) !== null && _props$classRemove$ou !== void 0 ? _props$classRemove$ou : "").twind(inject("twindEnable", true)).val(),
        innerWrapper: new Classy("inline-block min-w-full py-2 align-middle sm:px-6 lg:px-8").append((_props$classAppend$in = (_props$classAppend2 = props.classAppend) === null || _props$classAppend2 === void 0 ? void 0 : _props$classAppend2.innerWrapper) !== null && _props$classAppend$in !== void 0 ? _props$classAppend$in : "").remove((_props$classRemove$in = (_props$classRemove2 = props.classRemove) === null || _props$classRemove2 === void 0 ? void 0 : _props$classRemove2.innerWrapper) !== null && _props$classRemove$in !== void 0 ? _props$classRemove$in : "").twind(inject("twindEnable", true)).val()
      };
    });
    return {
      classes: classes
    };
  }
});

function render$6(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("div", {
    class: _ctx.classes.outerWrapper
  }, [createVNode("div", {
    class: _ctx.classes.innerWrapper
  }, [renderSlot(_ctx.$slots, "default")], 2)], 2);
}

script$5.render = render$6;

var script$6 = defineComponent({
  name: "Thead",
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Thead) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$7(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("thead", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$6.render = render$7;

var script$7 = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Tbody) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$8(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("tbody", null, [renderSlot(_ctx.$slots, "default")]);
}

script$7.render = render$8;

var script$8 = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].tr) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$9(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("tr", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$8.render = render$9;

var script$9 = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Th) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$a(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("th", {
    scope: "col",
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$9.render = render$a;

var script$a = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Td) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$b(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("td", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$a.render = render$b;

// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types, @typescript-eslint/no-explicit-any
var Theme$3 = (userTheme) => {
    return merge({
        primary: {
            Table: "min-w-full",
            Thead: "border-b border-gray-200 dark:border-gray-800 bg-gray-100 dark:bg-gray-800",
            Tbody: "",
            Tr: "border-b border-gray-200 dark:border-gray-700 last:border-0",
            Th: "px-6 pt-4 pb-3 text-left text-xs font-medium text-gray-500 dark:text-gray-400 uppercase tracking-wider",
            Td: "px-6 py-4 whitespace-nowrap text-sm text-gray-900 dark:text-gray-100",
        },
    }, userTheme ? userTheme.Table : null);
};

var Table = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _computed = computed(function () {
      return Theme$3(inject("userTheme", {}));
    }),
        theme = _computed.value;

    var classes = computed(function () {
      return new Classy(theme[props.variant].Table).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    provide("theme", theme);
    provide("variant", props.variant);
    return {
      tw: tw,
      classes: classes
    };
  }
});

function render$c(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("table", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

Table.render = render$c;

const TablePlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, Table);
    },
};

var componentsAsPlugins = /*#__PURE__*/Object.freeze({
	__proto__: null,
	AnchorPlugin: AnchorPlugin,
	ButtonPlugin: ButtonPlugin,
	DropdownPlugin: DropdownPlugin,
	DropdownButtonPlugin: DropdownButtonPlugin,
	DropdownItemsPlugin: DropdownItemsPlugin,
	DropdownItemPlugin: DropdownItemPlugin,
	TablePlugin: TablePlugin
});

// Install
function pluginSetup(config = {
    theme: false,
}) {
    // Merge default config with user config
    const twindOptions = merge({
        enable: true,
        setup: {
            mode: silent,
            darkMode: false,
        },
    }, config.twind);
    // Pass to Twind setup
    if (twindOptions.enable && twindOptions.setup) {
        setup(twindOptions.setup);
    }
    // Install Vue plugin
    const install = (app) => {
        for (const componentKey in componentsAsPlugins) {
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            app.use(componentsAsPlugins[componentKey]);
        }
        // Provide data to components
        app.provide("userTheme", config.theme);
        app.provide("twindEnable", twindOptions.enable);
    };
    return install;
}

export default pluginSetup;
export { script as Anchor, script$1 as Button, Dropdown, script$2 as DropdownButton, script$3 as DropdownItem, script$4 as DropdownItems, Table };
